Index: cprs/trunk/CPRS-Chart/Orders/fODBBank.pas
===================================================================
--- cprs/trunk/CPRS-Chart/Orders/fODBBank.pas	(revision 456)
+++ cprs/trunk/CPRS-Chart/Orders/fODBBank.pas	(revision 829)
@@ -1273,238 +2378,556 @@
 end;
 
+procedure TfrmODBBank.cboQuickClick(Sender: TObject);
+begin
+  inherited;
+  SetOnQuickOrder;
+end;
+
+procedure TfrmODBBank.cboReasonsChange(Sender: TObject);
+begin
+  inherited;
+  if (length(cboReasons.Text) > 75) then
+    begin
+      ShowMsg('REASON FOR REQUEST cannot be longer than 75 characters');
+      cboReasons.Text := Copy(cboReasons.Text,0,75);
+      Exit;
+    end;
+  if Length(cboReasons.Text) > 0 then Responses.Update('REASON', 1, cboReasons.Text, cboReasons.Text);
+  memOrder.Text := Responses.OrderText;
+end;
+
+procedure TfrmODBBank.cboReasonsEnter(Sender: TObject);
+begin
+  inherited;
+  if Length(cboReasons.Text) > 0 then
+    uReason := cboReasons.Text;
+end;
+
+procedure TfrmODBBank.cboReasonsExit(Sender: TObject);
+begin
+  inherited;
+  if Length(cboReasons.Text) > 0 then
+    uReason := cboReasons.Text;
+end;
+
 procedure TfrmODBBank.cboAvailTestSelect(Sender: TObject);
 var
-  x: string;
   i: integer;
-begin
-  DisableComponentControls;
-  EnableDiagTestControls;
-  LRORDERMODE := TORDER_MODE_DIAG;
-  with cboAvailTest do
-    begin
-      if (Length(ItemID) = 0) or (ItemID = '0') then Exit;
+  text : string;
+  ListItem: TListItem;
+  aCollTime,aTypeScreen,aStr,aModifier,aSpecimen,aTestYes,x,aName,aTNSString: string;
+  aList: TStringList;
+  curAdd,AnInstance,aTNS,aTNSDays: Integer;
+  sub,sub1: string;
+  AResponse: TResponse;
+begin
+  if cboAvailTest.ItemID = '' then Exit;
+  aList := TStringList.Create;
+  try
+    ALabTest := nil;
+    aTypeScreen := '';
+    aSpecimen := '^';
+    aTestYes := '1';
+    aModifier := '';
+    changing := true;
+    tQuantity.Text := '';
+    sub1 := '';
+    cboModifiers.ItemIndex := -1;
+    DisableComponentControls;
+    EnableDiagTestControls;
+    LRORDERMODE := TORDER_MODE_DIAG;
+    ALabTest := TLabTest.Create(cboAvailTest.ItemID, Responses);
+    sub := GetSubtype(ALabTest.TestName);
+    with CtrlInits do
+        begin
+          SetControl(cboCollType, 'Collection Types');
+          LoadCollType(cboCollType);
+          if FLastCollType <> '' then
+            cboCollType.SelectByID(FLastCollType)
+          else if uDfltCollType <> '' then
+            cboCollType.SelectByID(uDfltCollType)
+          else if OrderForInpatient then
+            if (ALabTest.LabCanCollect) then
+              cboCollType.SelectByID('LC')
+            else
+              cboCollType.SelectByID('WC')
+          else
+            cboCollType.SelectByID('SP');
+          SetupCollTimes(cboCollType.ItemID);
+        end;
+    with cboAvailTest do
+      begin
+        if (Length(ItemID) = 0) or (ItemID = '0') then Exit;
+        FLastLabID := ItemID ;
+        FLastItemID := ItemID;
+        for i := 0 to uSelectedItems.Count - 1 do
+          if ItemID = piece(uSelectedItems[i],'^',2) then
+            begin
+              ItemIndex := -1;
+              lvSelectionList.Items[i].Selected := true;
+              lvSelectionListClick(self);
+              Exit;
+            end;
+        Changing := True;
+        Changing := False;
+        ExtractTypeScreen(aList, uVBECList);
+        if aList.Count > 0 then aTypeScreen := aList[0];
+        aList.Clear;
+        aTNSString := '';
+        if (StrToInt(aTypeScreen) = cboAvailTest.ItemID) and (uTNSOrders.Count > 0) then
+          begin
+            for i := 0 to uTNSOrders.Count - 1 do
+              aTNSString := aTNSString + CRLF + uTNSOrders[i];
+            with Application do
+              begin
+                NormalizeTopMosts;
+                aTNSDays := TNSDaysBack;
+                aTNS :=
+                  MessageBox(PChar(aTNSString + CRLF + CRLF +
+                             'Do you wish to continue?'),
+                             PChar('Type & Screen Entered in Past ' + IntToStr(TNSDaysBack) + ' Days'),
+                             MB_YESNO);
+                RestoreTopMosts;
+                if aTNS = 7 then
+                  begin
+                    cboAvailTest.ItemIndex := -1;
+                    exit;
+                  end;
+              end;
+          end;
+        if sub = 't' then with ALabTest do      //DIAGNOSTIC TEST
+          begin
+            if ObtainCollSamp then
+              begin
+              //For BloodBank orders, this condition should never occur
+              end
+            else
+              begin
+                with ALabTest do
+                  with TCollSamp(CollSampList.Items[IndexOfCollSamp(CollSamp)]) do
+                    begin
+                      x := '' ;
+                      for i := 0 to WardComment.Count-1 do
+                      x := x + WardComment.strings[i]+#13#10 ;
+                      pnlMessage.TabOrder := cboAvailTest.TabOrder + 1;
+                      OrderMessage(x) ;
+                    end ;
+              end;
+        end;
+        Changing := False;
+      end;
+    if LRORDERMODE = TORDER_MODE_DIAG then
+      begin
+        if Length(calWantTime.Text) > 0 then Responses.Update('DATETIME',1,ValidCollTime(calWantTime.Text),calWantTime.Text);
+        with cboCollType do if Length(ItemID) > 0 then
+          begin
+            Responses.Update('COLLECT', 1, ItemID, ItemID) ;
+            FLastCollType := ItemID;
+          end;
+        if Length(cboUrgency.Text) > 0 then Responses.Update('URGENCY',1,cboUrgency.ItemID,cboUrgency.Text)
+        else
+          begin
+            cboUrgency.ItemIndex := 1;
+            Responses.Update('URGENCY',1,cboUrgency.ItemID,cboUrgency.Text);
+          end;
+        if Length(memDiagComment.Text) > 0 then Responses.Update('COMMENT',1,memDiagComment.Text,memDiagComment.Text);
+        if Length(cboReasons.Text) > 0 then Responses.Update('REASON',1,cboReasons.Text,cboReasons.Text);
+        if cboCollType.ItemID = 'LC' then
+          begin
+            with cboCollTime do
+              if Length(ItemID) > 0 then
+                begin
+                  Responses.Update('START', 1, Copy(ItemID, 2, 999), Copy(ItemID, 2, 999));
+                  FLastLabCollTime := ItemID + U + Text;
+                end
+              else if Length(Text) > 0 then
+                begin
+                  Responses.Update('START', 1, ValidCollTime(Text), Text) ;
+                  FLastLabCollTime := ValidCollTime(Text);
+                end;
+          end
+          else
+            begin
+              with calCollTime do
+                if FMDateTime > 0 then
+                  begin
+                    Responses.Update('START', 1, ValidCollTime(Text), Text);
+                    FLastColltime := ValidCollTime(Text);
+                  end
+                else
+                  begin
+                    Responses.Update('START', 1, '', '') ;
+                    FLastCollTime := '';
+                  end;
+            end;
+          if Length(cboCollType.Text) > 0 then Responses.Update('COLLECT',1,cboCollType.ItemID,cboCollType.ItemID);
+      end;
+    if length(cboCollTime.ItemID) > 0 then aCollTime := cboCollTime.Items[cboCollTime.ItemIndex];
+    uTestSelected := true;
+    with lvSelectionList do
+      begin
+        ListItem := Items.Add;
+        ListItem.Caption := piece(cboAvailTest.Items[cboAvailTest.ItemIndex],'^',2);
+        ListItem.SubItems.Add('');
+        ListItem.SubItems.Add('');
+        ListItem.SubItems.Add('');
+        ListItem.SubItems.Add(piece(cboAvailTest.Items[cboAvailTest.ItemIndex],'^',1));
+        if piece(cboAvailTest.Items[cboAvailTest.ItemIndex],'^',1) = aTypeScreen then
+          begin
+            lblTNS.Caption := '';
+            lblTNS.Visible := false;
+            memMessage.Text := '';
+            pnlMessage.Visible := false;
+            uGetTnS := 0;
+            pnlDiagnosticTests.Caption := 'Diagnostic Tests';
+          end;
+      end;
+    aStr := aTestYes + '^' + IntToStr(aLabTest.TestID) + '^' + tQuantity.Text + '^' + aModifier + '^' + aSpecimen + '^' + aCollTime + '^' + cboCollType.Text + '^' + IntToStr(aLabTest.ItemID);  //aSpecimen has 2 pieces
+    uSelectedItems.Add(aStr);
+    CurAdd := 1;
+    for i := 0 to uSelectedItems.Count - 1 do
+      begin
+        aName := lvSelectionList.Items[i].Caption;
+        x := uSelectedItems[i];
+        if piece(x,'^',1) = '1' then    //Diagnostic Test related fields
+          begin
+            if Length(piece(x,'^',2)) > 0 then Responses.Update('ORDERABLE', CurAdd, piece(x,'^',2), aName);
+          end;
+        Inc(CurAdd);
+      end;
+    memOrder.Text := Responses.OrderText;
+  finally
+    aList.Free;
+  end;
+  edtResults.Height := 247;
+  edtInfo.Height := 247;
+  if lvSelectionList.Items.Count > 0 then
+    begin
+      pnlSelectedTests.Visible := True;
+      cmdAccept.Visible := True;
+      memOrder.Visible := True;
+      GroupBox1.Visible := False;
+    end;
+end;
+
+procedure TfrmODBBank.cboAvailCompSelect(Sender: TObject);
+ var
+  aList,aTests: TStringList;
+  i,j,k,getTest,TestAdded: integer;
+  text : string;
+  aMSBOS,aMSBOSContinue,curAdd,AnInstance: integer;
+  sub,sub1: string;
+  AResponse: TResponse;
+  ListItem: TListItem;
+  aTypeScreen,aSpecimen,aTestYes,aStr,aMsg,aModifier,x,x1,aReason,aSurgery,aCollTime,aCollSave,aName: String;
+begin
+  if cboAvailComp.ItemID = '' then Exit;
+  aList := TStringList.Create;
+  aTests := TStringList.Create;
+  sub1 := '';
+  try
+    DisableDiagTestControls;
+    EnableComponentControls;
+    if not(changing = true) then
+      begin
+        changing := true;
+        tQuantity.Text := '';
+        cboModifiers.ItemIndex := -1;
+        changing := false;
+      end;
+    LRORDERMODE := TORDER_MODE_COMP;
+    with cboAvailComp do
+      begin
+        if (Length(ItemID) = 0) or (ItemID = '0') then Exit;
+        FLastLabID := ItemID ;
+        FLastItemID := ItemID;
+        for i := 0 to uSelectedItems.Count - 1 do
+          if ItemID = piece(uSelectedItems[i],'^',2) then
+            begin
+              ItemIndex := -1;
+              lvSelectionList.Items[i].Selected := true;
+              lvSelectionListClick(self);
+              Exit;
+            end;
+        ALabTest := TLabTest.Create(ItemID, Responses);
+        sub := GetSubtype(ALabTest.TestName);
+        Changing := False;
+        StatusText('');
+      end;
+    //Check for and display any associated Lab Results
+    aList.Clear;
+    TestAdded := 0;
+    getTest := 0;
+    ExtractTests(aList, uVBECList);   //Get Results associated with ordered components
+      for j := 0 to aList.Count - 1 do
+        begin
+          if StrToInt(piece(aList[j],'^',1)) = aLabTest.ItemID then
+            begin
+              if uTestsForResults.Count < 1 then getTest := 1;
+              for k := 0 to uTestsForResults.Count - 1 do
+                begin
+                  if piece(uTestsForResults[k],'^',1) = piece(aList[j],'^',3) then
+                    begin
+                      getTest := 0;
+                      break;
+                    end
+                  else getTest := 1;
+                end;
+              if getTest = 1 then
+                begin
+                  uTestsForResults.Add(piece(aList[j],'^',3));
+                  TestAdded := 1;
+                end;
+            end;
+        end;
+      if TestAdded = 1 then
+        begin
+          edtResults.Clear;
+          aTests.Clear;
+          GetPatientBloodResults(aTests, Patient.DFN, uTestsForResults);
+          QuickCopy(ATests,edtResults);
+          if edtResults.Lines.Count > 0 then TabResults.Caption := 'Lab Results Available';
+          uRaw.Clear;
+          GetPatientBloodResultsRaw(uRaw, Patient.DFN, uTestsForResults);
+        end;
+      CurAdd := 1;
+      if uRaw.Count > 0 then
+      for j := 0 to uRaw.Count - 1 do
+        begin
+          if Length(uRaw[j]) > 0 then Responses.Update('RESULTS', CurAdd, uRaw[j], piece(uRaw[j],'^',1));
+          Inc(CurAdd);
+        end;
+    aTypeScreen := '';
+    aSpecimen := '^';
+    aTestYes := '0';
+    aReason := '';
+    aSurgery := '';
+    aCollTime := '';
+    aList.Clear;
+    ExtractTypeScreen(aList, uVBECList);
+    if aList.Count > 0 then aTypeScreen := aList[0];
+    aList.Clear;
+    ExtractSpecimen(aList, uVBECList);
+    if aList.Count > 0 then aSpecimen := aList[0];
+    if length(cboModifiers.ItemID) > 0 then aModifier := cboModifiers.Items[cboModifiers.ItemIndex];
+    if length(cboReasons.ItemID) > 0 then aReason := cboReasons.Items[cboReasons.ItemIndex];
+    if length(cboSurgery.ItemID) > 0 then aSurgery := cboSurgery.Items[cboSurgery.ItemIndex];
+    if length(cboCollTime.ItemID) > 0 then aCollTime := cboCollTime.Items[cboCollTime.ItemIndex];
+    if Length(cboSurgery.ItemID) > 0 then
+      begin
+        aList.Clear;
+        ExtractMSBOS(aList, uVBECList);    //Get maximum units for selected Surgey
+        for i := 0 to aList.Count - 1 do
+          begin
+            if (StrToInt(piece(aList[i],'^',1)) = aLabTest.ItemID)
+             and (piece(aList[i],'^',3) = cboSurgery.Text) then
+              begin
+                aMSBOS := StrToInt(piece(aList[i],'^',4));
+                if (aMSBOS > 0) and (Length(tQuantity.Text) > 0) and (StrToInt(tQuantity.Text) > aMSBOS) then
+                  begin
+                    with Application do
+                    begin
+                      NormalizeTopMosts;
+                      aMSBOSContinue :=
+                        MessageBox(PChar('The number of units ordered (' + tQuantity.Text +
+                                   ') for ' + aLabTest.TestName + ' exceeds the maximum number of units ('
+                                   + IntToStr(aMSBOS) +
+                                   ') for the ' + cboSurgery.text +
+                                   ' surgical procedure selected.' + CRLF + CRLF + 'Do you wish to continue?'),
+                                   PChar('Maximum Number of Units Exceeded'),
+                                   MB_YESNO);
+                      RestoreTopMosts;
+                    end;
+                    if aMSBOSContinue = 7 then
+                      begin
+                        ShowMsg(cboAvailComp.Text + ' has NOT been added to this request.');
+                        exit;
+                      end;
+                  end;
+              end;
+          end;
+      end;
+    if (uTNSOrders.Count < 1) then // SpecimenNeeded(aList, uVBECList, aLabTest.ItemID) then  //check to see if type and screen is needed
+      begin
+        uGetTnS := 1;
+        for i := 0 to lvSelectionList.Items.Count - 1 do
+          begin
+            if lvSelectionList.Items[i].SubItems[3] = aTypeScreen then
+              begin
+                uGetTnS := 0;
+                if length(cboUrgency.ItemID) > 0 then uDfltUrgency := cboUrgency.ItemID;
+                lblTNS.Caption := '';
+                lblTNS.Visible := false;
+                memMessage.Text := '';
+                pnlMessage.Visible := false;
+                pnlDiagnosticTests.Caption := 'Diagnostic Tests';
+                break;
+              end;
+          end;
+      end;
+    aList.Clear;
+    ExtractSpecimens(aList, uVBECList);    //Get specimen values to pass back to Server
+    for i := 0 to aList.Count - 1 do
+      begin
+        if (StrToInt(piece(aList[i],'^',1)) = aLabTest.ItemID) then
+          begin
+            aSpecimen := piece(aList[i],'^',2) + '^' + aSpecimen;
+            break;
+          end;
+      end;
+    uComponentSelected := true;
+    with lvSelectionList do
+      begin
+        ListItem := Items.Add;
+        ListItem.Caption := piece(cboAvailComp.Items[cboAvailComp.ItemIndex],'^',2);
+        ListItem.SubItems.Add(tQuantity.Text);
+        if length(cboModifiers.ItemID) > 0 then
+          begin
+            ListItem.SubItems.Add(cboModifiers.Items[cboModifiers.ItemIndex]);
+            ListItem.SubItems.Add(IntToStr(cboModifiers.ItemIndex));
+          end
+          else
+            begin
+              ListItem.SubItems.Add('');
+              ListItem.SubItems.Add('');
+            end;
+        ListItem.SubItems.Add(piece(cboAvailComp.Items[cboAvailComp.ItemIndex],'^',1));
+      end;
+      aStr := aTestYes + '^' + IntToStr(aLabTest.TestID) + '^' + tQuantity.Text + '^' + aModifier + '^' + aSpecimen + '^' + IntToStr(aLabTest.ItemID);  //aSpecimen has 2 pieces additional pieces added for Tests
+      uSelectedItems.Add(aStr);
+      CurAdd := 1;
       for i := 0 to uSelectedItems.Count - 1 do
-        if ItemID = piece(uSelectedItems[i],'^',1) then
+        begin
+          aName := lvSelectionList.Items[i].Caption;
+          x := uSelectedItems[i];
+          if piece(x,'^',1) = '1' then    //Diagnostic Test related fields
+            begin
+              if Length(piece(x,'^',2)) > 0 then Responses.Update('ORDERABLE', CurAdd, piece(x,'^',2), aName);
+            end
+          else
+            begin
+              if Length(piece(x,'^',2)) > 0 then Responses.Update('ORDERABLE', CurAdd, piece(x,'^',2), aName);
+              if Length(piece(x,'^',3)) > 0 then Responses.Update('QTY', CurAdd, piece(x,'^',3), piece(x,'^',3));
+              if Length(piece(x,'^',4)) > 0 then Responses.Update('MODIFIER', CurAdd, piece(x,'^',4), piece(x,'^',4));
+              if Length(piece(x,'^',5)) > 0 then Responses.Update('SPECSTS', CurAdd, pieces(x,'^',5,7), piece(x,'^',5));
+              if Length(cboSurgery.Text) > 0 then Responses.Update('MISC',1,cboSurgery.Text,cboSurgery.Text);
+              if Length(calWantTime.Text) > 0 then Responses.Update('DATETIME',1,ValidCollTime(calWantTime.Text),calWantTime.Text);
+              if Length(cboUrgency.Text) > 0 then Responses.Update('URGENCY',1,cboUrgency.ItemID,cboUrgency.Text)
+                else
+                  begin
+                    cboUrgency.ItemIndex := 1;
+                    Responses.Update('URGENCY',1,cboUrgency.ItemID,cboUrgency.Text);
+                  end;
+            end;
+          Inc(CurAdd);
+        end;
+      memOrder.Text := Responses.OrderText;
+  finally
+    alist.Free;
+    aTests.Free;
+  end;
+  aMsg := '';
+  LRORDERMODE := TORDER_MODE_INFO;
+  if uGetTnS = 1 then
+    begin
+      lblTNS.Caption := 'TYPE + SCREEN must be added to order';
+      lblTNS.Visible := true;
+      memMessage.Text := 'TYPE + SCREEN must be added to order';
+      pnlMessage.Visible := true;
+      pnlDiagnosticTests.Caption := 'Diagnostic Tests*';
+    end;
+  {if uGetTnS = 1 then
+    begin
+      if responses.QuickOrder < 1 then
+        begin
+          for i := 1 to cboAvailTest.Items.Count - 1 do
+            begin
+              if piece(cboAvailTest.Items[i],'^',1) = aTypeScreen then
+                begin
+                  if piece(aSpecimen,'^',1) = '1' then
+                    begin
+                      cboCollTime.Text := calWantTime.Text;
+                      aCollSave := cboCollTime.Text + '^' + cboCollTime.ItemID + '^' + cboCollType.Text + '^' + cboCollType.ItemID;
+                      cboCollTime.Text := '';
+                      cboCollType.Text := '';
+                      uSpecimen := 1;
+                    end;
+                  cboModifiers.Text := '';
+                  cboAvailTest.SelectByID(aTypeScreen);
+                  cboTests.SelectByID(aTypeScreen);
+                  cboTestsClick(self);
+                  //cboAvailTestSelect(Self);
+                  uSpecimen := 0;
+                  cboCollTime.Text := piece(aCollSave,'^',1);
+                  cboCollType.Text := piece(aCollSave,'^',3);
+                  aCollSave := '';
+                  break;
+                end;
+            end;
+          aMsg := 'An order for Type and Screen has been added to this request' + '.';
+        end
+        else
           begin
-            ShowMessage('This test has already been selected!');
-            Exit;
+            lblTNS.Caption := 'TYPE + SCREEN must be added to order';
+            lblTNS.Visible := true;
+            memMessage.Text := 'TYPE + SCREEN must be added to order';
+            memMessage.Visible := false;
+            pnlMessage.Visible := true;
           end;
-      FLastLabID := ItemID ;
-      FLastItemID := ItemID;
-      Changing := True;
-      if Sender <> Self then
-        Responses.Clear;       // Sender=Self when called from SetupDialog
-      if CharAt(ItemID, 1) = 'Q' then
-        with Responses do
-          begin
-            FLastItemID := ItemID;
-            QuickOrder := ExtractInteger(ItemID);
-            SetControl(cboAvailTest, 'ORDERABLE', 1);
-            if (Length(ItemID) = 0) or (ItemID = '0') then Exit;
-            FLastLabID := ItemID;
-          end;
-      ALabTest := TLabTest.Create(ItemID, Responses);
-    end;
-  with ALabTest do
-  begin
-
-    {with Responses do if QuickOrder > 0 then
-     begin
-      StatusText('Initializing Quick Order');
-      Changing := True;
-      SetControl(cboAvailTest,       'ORDERABLE', 1);
-      DetermineCollectionDefaults(Responses);
-      LoadUrgency(cboCollType.ItemID, cboUrgency);
-      SetControl(cboUrgency,         'URGENCY', 1);
-      Urgency := cboUrgency.ItemIEN;
-      if (Urgency = 0) and (cboUrgency.Items.Count = 1) then
-        begin
-          cboUrgency.ItemIndex := 0;
-          Urgency := cboUrgency.ItemIEN;
-        end;
-      tmpResp := FindResponseByName('SPECIMEN'  ,1);
-      i := 1 ;
-      tmpResp := Responses.FindResponseByName('COMMENT',i);
-      while tmpResp <> nil do
-        begin
-          Comment.Add(tmpResp.EValue);
-          Inc(i);
-          tmpResp := Responses.FindResponseByName('COMMENT',i);
-        end ;
-      end;  //  Quick Order}
-    if ObtainCollSamp then
-      begin
-        //For BloodBank orders, this condition should never occur
-      end
+      end;
+  if (uGetTnS = 1) then
+    begin
+      if length(aMsg) > 0 then aMsg := aMsg + crlf + crlf;
+      ShowMsg(aMsg);
+    end;  }
+  edtResults.Height := 247;
+  edtInfo.Height := 247;
+  if lvSelectionList.Items.Count > 0 then
+    begin
+      pnlSelectedTests.Visible := True;
+      cmdAccept.Visible := True;
+      memOrder.Visible := True;
+      GroupBox1.Visible := False;
+    end;
+  if tQuantity.CanFocus = true then tQuantity.SetFocus;
+end;
+
+procedure TfrmODBBank.DisableCommentPanels;
+begin
+  lblReqComment.Visible := False;
+end;
+
+procedure TfrmODBBank.DisableComponentControls;
+begin
+  lblQuantity.Enabled := false;
+  tQuantity.Enabled := false;
+  lblModifiers.Enabled := false;
+  cboModifiers.Enabled := false;
+  cboAvailComp.ItemIndex := -1;
+end;
+
+procedure TfrmODBBank.EnableComponentControls;
+begin
+  lblQuantity.Enabled := true;
+  tQuantity.Enabled := true;
+  lblModifiers.Enabled := true;
+  cboModifiers.Enabled := true;
+  if not(changing) then
+    if not(uSelUrgency = 'PRE-OP') then
+      if uSelUrgency = '' then
+        if lvSelectionList.Items.Count < 1 then
+          cboUrgency.SelectByID(IntToStr(uDfltUrgency));
+  if cboUrgency.Text = 'PRE-OP' then
+    begin
+      lblSurgery.Enabled := true;
+      cboSurgery.Enabled := true;
+      lblSurgery.Caption := 'Surgery*';
+    end
     else
       begin
-        with ALabTest do
-          with TCollSamp(CollSampList.Items[IndexOfCollSamp(CollSamp)]) do
-            begin
-              x := '' ;
-              for i := 0 to WardComment.Count-1 do
-                x := x + WardComment.strings[i]+#13#10 ;
-              pnlMessage.TabOrder := cboAvailTest.TabOrder + 1;
-              OrderMessage(x) ;
-            end ;
+        lblSurgery.Enabled := false;
+        cboSurgery.Enabled := false;
+        lblSurgery.Caption := 'Surgery';
       end;
-    if ObtainComment then
-      LoadRequiredComment(FCmtTypes.IndexOf(CurReqComment))
-    else
-      DisableCommentPanels;
-    x := '' ;
-    for i := 0 to CurWardComment.Count-1 do
-      x := x + CurWardComment.strings[i]+#13#10 ;
-    i :=  IndexOfCollSamp(CollSamp);
-    if i > -1 then with TCollSamp(CollSampList.Items[IndexOfCollSamp(CollSamp)]) do
-       for i := 0 to WardComment.Count-1 do
-         x := x + WardComment.strings[i]+#13#10 ;
-    pnlMessage.TabOrder := cboAvailTest.TabOrder + 1;
-    OrderMessage(x) ;
-   end; { with }
-  StatusText('');
-  Changing := False;
-end;
-
-procedure TfrmODBBank.cboAvailCompSelect(Sender: TObject);
-var
-  x: string;
-  i: integer;
-begin
-  DisableDiagTestControls;
-  EnableComponentControls;
-  LRORDERMODE := TORDER_MODE_COMP;
-  with cboAvailComp do
-    begin
-      if (Length(ItemID) = 0) or (ItemID = '0') then Exit;
-      for i := 0 to uSelectedItems.Count - 1 do
-        if ItemID = piece(uSelectedItems[i],'^',1) then
-          begin
-            ShowMessage('This component has already been selected!');
-            Exit;
-          end;
-      FLastLabID := ItemID ;
-      FLastItemID := ItemID;
-      Changing := True;
-      if Sender <> Self then
-        Responses.Clear;       // Sender=Self when called from SetupDialog
-      if CharAt(ItemID, 1) = 'Q' then
-        with Responses do
-          begin
-            FLastItemID := ItemID;
-            QuickOrder := ExtractInteger(ItemID);
-            SetControl(cboAvailComp, 'ORDERABLE', 1);
-            if (Length(ItemID) = 0) or (ItemID = '0') then Exit;
-            FLastLabID := ItemID;
-          end;
-      ALabTest := TLabTest.Create(ItemID, Responses);
-    end;
-  with ALabTest do
-  begin
-
-    {with Responses do if QuickOrder > 0 then
-     begin
-      StatusText('Initializing Quick Order');
-      Changing := True;
-      SetControl(cboAvailTest,       'ORDERABLE', 1);
-      DetermineCollectionDefaults(Responses);
-      LoadUrgency(cboCollType.ItemID, cboUrgency);
-      SetControl(cboUrgency,         'URGENCY', 1);
-      Urgency := cboUrgency.ItemIEN;
-      if (Urgency = 0) and (cboUrgency.Items.Count = 1) then
-        begin
-          cboUrgency.ItemIndex := 0;
-          Urgency := cboUrgency.ItemIEN;
-        end;
-      tmpResp := FindResponseByName('SPECIMEN'  ,1);
-      i := 1 ;
-      tmpResp := Responses.FindResponseByName('COMMENT',i);
-      while tmpResp <> nil do
-        begin
-          Comment.Add(tmpResp.EValue);
-          Inc(i);
-          tmpResp := Responses.FindResponseByName('COMMENT',i);
-        end ;
-      end;  //  Quick Order}
-    {if ObtainCollSamp then
-      begin
-        // should not occur with Blood orders
-      end
-    else
-      begin
-        with ALabTest do
-          with TCollSamp(CollSampList.Items[IndexOfCollSamp(CollSamp)]) do
-            begin
-              x := '' ;
-              for i := 0 to WardComment.Count-1 do
-                x := x + WardComment.strings[i]+#13#10 ;
-              pnlMessage.TabOrder := cboAvailTest.TabOrder + 1;
-              OrderMessage(x) ;
-            end ;
-      end;
-     }
-    if ObtainComment then
-      LoadRequiredComment(FCmtTypes.IndexOf(CurReqComment))
-    else
-      DisableCommentPanels;
-    x := '' ;
-    for i := 0 to CurWardComment.Count-1 do
-      x := x + CurWardComment.strings[i]+#13#10 ;
-    i :=  IndexOfCollSamp(CollSamp);
-    if i > -1 then with TCollSamp(CollSampList.Items[IndexOfCollSamp(CollSamp)]) do
-       for i := 0 to WardComment.Count-1 do
-         x := x + WardComment.strings[i]+#13#10 ;
-    pnlMessage.TabOrder := cboAvailComp.TabOrder + 1;
-    OrderMessage(x) ;
-   end; { with }
-  StatusText('');
-  Changing := False;
-end;
-
-procedure TfrmODBBank.DisableCommentPanels;
-begin
-  lblReqComment.Visible := False;
-end;
-
-procedure TfrmODBBank.DisableComponentControls;
-begin
-  lblModifiers.Enabled := false;
-  cboModifiers.Enabled := false;
-  lblWanted.Enabled := false;
-  calWantTime.Enabled := false;
-  //lblPreparation.Enabled := false;
-  //cboPreparation.Enabled := false;
-  lblSurgery.Enabled := false;
-  cboSurgery.Enabled := false;
-  lblReason.Enabled := false;
-  tReason.Enabled := false;
-  chkConsent.Enabled := false;
-  lblQuantity.Enabled := false;
-  tQuantity.Enabled := false;
-  upQuantity.Enabled := false;
-  cboAvailComp.ItemIndex := -1;
-  tQuantity.Text := '0';
-end;
-
-procedure TfrmODBBank.EnableComponentControls;
-begin
-  lblModifiers.Enabled := true;
-  cboModifiers.Enabled := true;
-  lblWanted.Enabled := true;
-  calWantTime.Enabled := true;
-  //lblPreparation.Enabled := true;
-  //cboPreparation.Enabled := true;
-  if cboUrgency.Text = 'PRE-OP' then
-    begin
-      lblSurgery.Enabled := true;
-      cboSurgery.Enabled := true;
-    end;
-  lblReason.Enabled := true;
-  tReason.Enabled := true;
-  chkConsent.Enabled := true;
-  lblQuantity.Enabled := true;
-  tQuantity.Enabled := true;
-  upQuantity.Enabled := true;
-  txtDiagComment.Enabled := true;
   lblDiagComment.Enabled := true;
 end;
@@ -1515,14 +2938,13 @@
   calCollTime.Enabled := false;
   cboCollTime.Enabled := false;
-  cboAvailTest.ItemIndex := -1;
   lblCollType.Enabled := false;
   cboCollType.Enabled := false;
   cmdImmedColl.Enabled := false;
+  cboAvailTest.ItemIndex := -1;
+  cboAvailTest.InitLongList('');
 end;
 
 procedure TfrmODBBank.EnableDiagTestControls;
 begin
-  calWantTime.Enabled := true;
-  lblWanted.Enabled := true;
   lblCollTime.Enabled := true;
   calCollTime.Enabled := true;
@@ -1530,9 +2952,10 @@
   lblCollType.Enabled := true;
   cboCollType.Enabled := true;
-  lblUrgency.Enabled := true;
-  cboUrgency.Enabled := true;
-  txtDiagComment.Enabled := true;
-  lblDiagComment.Enabled := true;
   cmdImmedColl.Enabled := true;
+  if not(changing) then
+    if not(uSelUrgency = 'PRE-OP') then
+      if uSelUrgency = '' then
+        if lvSelectionList.Items.Count < 1 then
+          cboUrgency.SelectByID(IntToStr(uDfltUrgency));
 end;
 
@@ -1548,4 +2971,5 @@
 begin
   if ALabTest = nil then exit;
+  if ALabTest.LabSubscript = 'BB' then exit;
   calCollTime.Clear;
   cboCollTime.Clear;
@@ -1618,4 +3042,11 @@
 end;
 
+procedure TfrmODBBank.cboAvailCompChange(Sender: TObject);
+begin
+  inherited;
+  changing := true;
+  changing := false;
+end;
+
 procedure TfrmODBBank.cboAvailCompExit(Sender: TObject);
 begin
